<?php

class Frame_Layer
{
    public function __construct()
    {
    }
    public function frame_request_order($order_id)
    {
        $order = wc_get_order( $order_id );
        $jsonString = array();
	$user_id = get_post_meta( $order_id, '_customer_user', true );
	        if($user_id){
                $customer = new WC_Customer( $user_id );
                $jsonString['contact_name'] = $order->get_billing_first_name().' '.$order->get_billing_last_name();
                $jsonString['first_name'] = $customer->get_billing_first_name();
                $jsonString['last_name'] = $customer->get_billing_last_name();
                $jsonString['email'] = $customer->get_billing_email();
                $jsonString['phone'] = $customer->get_billing_phone();
                $jsonString['contact_persons'][0]['first_name'] = $customer->get_first_name();
                $jsonString['contact_persons'][0]['last_name'] = $customer->get_last_name();
                $jsonString['contact_persons'][0]['email'] = $customer->get_email();
                $jsonString['contact_persons'][0]['phone'] = $customer->get_billing_phone();
        }else{
                $jsonString['contact_name'] = $order->get_billing_first_name().' '.$order->get_billing_last_name();
                $jsonString['first_name'] = $order->get_billing_first_name();
                $jsonString['last_name'] = $order->get_billing_last_name();
                $jsonString['email'] = $order->get_billing_email();
                $jsonString['phone'] = $order->get_billing_phone();
                $jsonString['contact_persons'][0]['first_name'] = $order->get_billing_first_name();
                $jsonString['contact_persons'][0]['last_name'] = $order->get_billing_last_name();
                $jsonString['contact_persons'][0]['email'] = $order->get_billing_email();
                $jsonString['contact_persons'][0]['phone'] = $order->get_billing_phone();
        }
        $jsonString['billing_address']['attention'] = $order->get_billing_first_name().' '.$order->get_billing_last_name();
        $jsonString['billing_address']['address'] = $order->get_billing_address_1();
        $jsonString['billing_address']['street2'] = $order->get_billing_address_2();
        //$jsonString['billing_address']['state_code'] = ;
        $jsonString['billing_address']['city'] = $order->get_billing_city();
        $jsonString['billing_address']['state'] = $order->get_billing_state();
        $jsonString['billing_address']['zip'] = $order->get_billing_postcode();
        $jsonString['billing_address']['country'] = $order->get_billing_country();
        $jsonString['billing_address']['phone'] = $order->get_billing_phone();

        $jsonString['shipping_address']['attention'] = $order->get_billing_first_name().' '.$order->get_billing_last_name();
        $jsonString['shipping_address']['address'] = $order->get_billing_address_1();
        $jsonString['shipping_address']['street2'] = $order->get_billing_address_2();
        $jsonString['shipping_address']['city'] = $order->get_billing_city();
        $jsonString['shipping_address']['state'] = $order->get_billing_state();
        $jsonString['shipping_address']['zip'] = $order->get_billing_postcode();
        $jsonString['shipping_address']['country'] = $order->get_billing_country();
        $jsonString['shipping_address']['phone'] = $order->get_billing_phone();

	$jsonString = json_encode($jsonString,TRUE);

	return $jsonString;
    }

    public function order_frame_request_order($is_present_id,$order_id)
    {
        $is_present_id = json_decode($is_present_id,TRUE);
$orderJson = array();
$order = wc_get_order( $order_id );
$orderJson['customer_id'] = $is_present_id['contactid'];
$orderJson['billing_address_id'] = $is_present_id['address_id'];
$orderJson['shipping_address_id'] = $is_present_id['address_id'];
$orderJson['discount_type'] = 'entity_level';
$orderJson['contact_persons'] = array($is_present_id['contact_person_id']);
$orderJson['is_inclusive_tax'] = FALSE;
$orderJson['order'] = date('Y-m-d');

$cuponDiscount = 0;
if(count($order->get_coupon_codes()) != 0)
{
foreach( $order->get_coupon_codes() as $coupon_code ) {
$coupon = new WC_Coupon($coupon_code);
$discount_type = $coupon->get_discount_type();
$coupon_amount = $coupon->get_amount();
if($discount_type == 'percent')
{
        $cuponDiscount = ($coupon_amount / 100) * $subTotal;
}
else
{
        $cuponDiscount = $coupon_amount;
}
}
}
if($cuponDiscount != 0)
{
$orderJson['discount_amount'] = $cuponDiscount;
$orderJson['discount'] = $cuponDiscount;
}

$i = 0;
foreach ( $order->get_items() as $item_id => $item ) {     
                if( $item['variation_id'] > 0 ){
                        $product_id = $item['variation_id']; // variable product
                } else {
                        $product_id = $item['product_id']; // simple product
                } 	

$itemId =  get_post_meta( $product_id,'_zoho_item_id' , TRUE);
$saleprice =  get_post_meta( $product_id,'_sale_price' , TRUE);
if($saleprice == '')
{
$saleprice =  get_post_meta( $product_id,'_price' , TRUE);
}
$orderJson['line_items'][$i]['item_id'] = $itemId;
$orderJson['line_items'][$i]['quantity'] = $item['quantity'];
$orderJson['line_items'][$i]['description'] = $item['description'];
$orderJson['line_items'][$i]['rate'] = $saleprice;
$i++;
}

$shipping_total = $order->get_shipping_total();

$orderJson['reference_number'] = 'WEB-'.$order_id;
$orderJson['shipping_charge'] = $shipping_total;
        $taxDescription = '';
$taxTotal = 0;
foreach( $order->get_items('tax') as $item ){
        $name        = $item->get_name(); // Get rate code name (item title)
        $rate_code   = $item->get_rate_code(); // Get rate code
        $rate_label  = $item->get_label(); // Get label
        $rate_id     = $item->get_rate_id(); // Get rate Id
        $tax_total   = $item->get_tax_total(); // Get tax total amount (for this rate)
        $ship_total  = $item->get_shipping_tax_total(); // Get shipping tax total amount (for this rate)
        $is_compound = $item->is_compound(); // check if is compound (conditional)
        $compound    = $item->get_compound(); // Get compound
        $taxTotal += ($item->get_tax_total() + $item->get_shipping_tax_total());
        $taxDescription .= $item->get_label()." ";
}

if($taxTotal > 0){
$orderJson['adjustment'] = $taxTotal;
$orderJson['adjustment_description'] = $taxDescription;
}

$orderJson1 = json_encode($orderJson,TRUE);

return $orderJson1;
    }

    public function invoice_frame_request($order_frame_request,$zohoOrderID,$order_id)
    {
            $orderJson = json_decode($order_frame_request,TRUE);	    
    	    $order = wc_get_order( $order_id );	    
	    $i =0;    
	    foreach ( $order->get_items() as $item_id => $item ) {
	    	    if(isset($zohoOrderID[$orderJson['line_items'][$i]['item_id']])){
		    	    $orderJson['line_items'][$i]['salesorder_item_id'] = $zohoOrderID[$orderJson['line_items'][$i]['item_id']];
	    	    }
	    	    $i++;
	    }
	    $orderJson['reference_number'] = $zohoOrderID['name'];
	    $orderJson['payment_options']['payment_gateways'][0]['gateway_name'] = 'paypal';
	    $orderJson['payment_options']['payment_gateways'][0]['additional_field1'] = 'standard';
	    $orderJson['payment_options']['payment_gateways'][1]['gateway_name'] = 'stripe';
	    $orderJson['payment_options']['payment_gateways'][2]['gateway_name'] = 'payments_pro';
	    $orderJson['payment_options']['payment_gateways'][3]['gateway_name'] = 'wepay';
	    $orderJson = json_encode($orderJson,TRUE);
	    return $orderJson;
    }

    public function payment_frame_request($handle_Contact,$invoiceResp,$order_id)
    {
                $order = wc_get_order( $order_id );
                $paymentJson['reference_number'] = $order->transaction_id;
                $paymentJson['payment_mode'] = "Web-".$order->get_payment_method();
                $paymentJson['customer_id'] = $is_present_id['contactid'];
                $paymentJson['amount'] = $order->get_total();
                $paymentJson['date'] = date('Y-m-d');
                $paymentJson['account_id'] = '2864327000000000361';
                $paymentJson['invoices'][0]['invoice_id'] = $invoiceResp['invoice']['invoice_id'];
		$paymentJson['invoices'][0]['amount_applied'] = $invoiceResp['invoice']['total'];
    		$paymentJson = json_encode($paymentJson,TRUE);
		return $paymentJson;
    }

    public function createSaleOrderNote($zohoOrderID,$order_id)
    {
                $order = wc_get_order( $order_id );
	        update_post_meta($order_id, 'zoho_sales_order_id', $zohoOrderID['id'] );
	    	$note = __('Zoho Sync says "'.$zohoOrderID["message"].'"');
	    	$order->add_order_note( $note );
    }

    public function createInvoiceNote($invoiceResp,$order_id)
    {
                $order = wc_get_order( $order_id );
	        update_post_meta($order_id, 'zoho_invoice_order_id', $invoiceResp['invoice']['invoice_id'] );
	    	$note = __('Zoho Sync says "'.$invoiceResp["message"].'"');
	    	$order->add_order_note( $note );
    }

    public function createPaymentNote($paymentResp,$order_id)
    {
                $order = wc_get_order( $order_id );
	        update_post_meta($order_id, 'zoho_payment_order_id', $paymentResp['payment']['payment_id'] );
	    	$note = __('Zoho Sync says "'.$paymentResp["message"].'"');
	    	$order->add_order_note( $note );
    }

}
