<?php
require_once plugin_dir_path(__FILE__) . '../includes/zohoAuth.php';
require_once plugin_dir_path(__FILE__) . '../includes/api_layer.php';
$zoho_auth = new zoho_auth();
$api = new Api_Layer();
$redirect_url = get_site_url().'/wp-admin/admin.php?page=wooBooks-getCode';
                global $wpdb;

                if(isset($_POST['submit1'])){
                $select_domain = $_POST['domain'];
                $url = get_site_url();
		$scope = "ZohoBooks.fullaccess.all";
                $redirect_uri = get_site_url().'/wp-admin/admin.php?page=wooBooks-getCode';
		$Client_id = $_POST['Client_id'];
		$Client_secret = $_POST['Client_secret'];		
		$select_domain = $_POST['domain'];
                $organization = $_POST['organization'];		
                $domains_link = array();
                $domains_link[] = "https://accounts.zoho.eu/oauth/v2/auth";
                $domains_link[] = "https://accounts.zoho.com.cn/oauth/v2/auth";
                $domains_link[] = "https://accounts.zoho.in/oauth/v2/auth";
                $domains_link[] = "https://accounts.zoho.com/oauth/v2/auth";
                $domain_name = array();
                $domain_name[] = "europe";
                $domain_name[] = "china";
                $domain_name[] = "india";
                $domain_name[] = "US";
		$domain = array_combine($domain_name, $domains_link);
		$new_credentials_value[] = $Client_id;
		$new_credentials_value[] = $Client_secret;
		$new_credentials_value[] = $select_domain;	
                if($organization != '')		
		{
                $new_credentials_value[] = $organization;			
		}
                $new_credentials_ids[] = 'zoho-books-client-id';
		$new_credentials_ids[] = 'zoho-books-client-secret';
		$new_credentials_ids[] = 'zoho-books-domain';		
                if($organization != '')         
		{
                $new_credentials_ids[] = 'zoho-books-org';           			
		}		
		$new_credentials = array_combine($new_credentials_ids, $new_credentials_value);

                $wp_option_find = $wpdb->get_results("SELECT * FROM wp_options where (option_name='zoho-books-client-id' or option_name='zoho-books-client-secret' or option_name='zoho-books-domain')");
                if ($wp_option_find){
                        foreach ($new_credentials as $key => $value) {
                                $update_sql = $wpdb->prepare("UPDATE wp_options SET option_value = '".$value."' WHERE option_name='".$key."'");
                                $wpdb->query($update_sql);
                        }

                }
                else{
                        foreach ($new_credentials as $key => $value) {
                                $wp_options = $wpdb->get_results("SELECT MAX(option_id) as 'id' FROM wp_options");
				$wp_options_max = $wp_options[0]->id;
				$tablename = "wp_options";
                        $wp_options_max_record = $wp_options_max + 1;
                        $insert_sql = "INSERT INTO ".$tablename."(option_id,option_name, option_value,autoload) VALUES('".$wp_options_max_record."','".$key."','".$value."','yes')";
                        $wpdb->query($insert_sql);
			}
		}

		$request_url = $domain[$select_domain].'?response_type=code&access_type=offline&client_id='.$Client_id.'&scope='.$scope.'&redirect_uri='.$redirect_uri.'&prompt=consent';

		header("Location: $request_url");
                wp_die();
		}

		if($_POST['submit_disconnect'])
		{
			$wp_delete_query = $wpdb->get_results("DELETE FROM wp_options where (option_name='zoho-books-client-id' or option_name='zoho-books-client-secret' or option_name='zoho-books-grant-token' or option_name='zoho-books-refreshtoken' or option_name='zoho-books-redirect-uri' or option_name='zoho-books-domain' or option_name='zoho-books-org')");		
			$zoho_url = get_site_url().'/wp-admin/admin.php?page=wooBooks-sync';			
			header("Location: $zoho_url");
			wp_die();			
		}

		$wp_option_find = $wpdb->get_results("SELECT * FROM wp_options where (option_name='zoho-books-client-id' or option_name='zoho-books-client-secret' or option_name='zoho-books-grant-token' or option_name='zoho-books-refreshtoken' or option_name='zoho-books-redirect-uri' or option_name='zoho-books-domain')");

        if ($wp_option_find){
                $zoho_client_id = get_option( 'zoho-books-client-id' );
                $zoho_client_secret = get_option( 'zoho-books-client-secret' );
                $zoho_client_grant = get_option( 'zoho-books-grant-token' );
                $zoho_client_redirecturi = get_option( 'zoho-books-redirect-uri' );
                $zoho_client_refreshtoken = get_option( 'zoho-books-refreshtoken' );
		$zoho_client_domain = get_option( 'zoho-books-domain' );
		$generate_refersh_token = $zoho_auth->getAccessToken();
		$getOrgs = $api->getOrgs($generate_refersh_token); 
		$organizations = $getOrgs['organizations'];
                $zoho_books_org = get_option( 'zoho-books-org' );		
        }

?>
<!DOCTYPE html>
<html>
<head>
<title>Form</title>     
</head>
<body>
<button class="accordion">Configuration</button>
<div class="panel">

<div class="go_zoho">
        <button id="zoho" class="button" >Go to ZOHO API Console</button>
</div>
<div class="main">
<div class="go_server">
<h2>Zoho Books API Connection</h2>
<form method="POST" action="" class="form1">
        <div class="items_domain">
                <div class="items_domain_item">
                        <label for="domain">Choose a Domain: </label>
				<select name="domain" id="domain">
                                <option value="US" <?php if($zoho_client_domain=="US") echo 'selected="selected"'; ?>>US</option>
                                <option value="europe" <?php if($zoho_client_domain=="europe") echo 'selected="selected"'; ?>>Europe</option>
                                <option value="china" <?php if($zoho_client_domain=="china") echo 'selected="selected"'; ?>>China</option>
                                <option value="india" <?php if($zoho_client_domain=="india") echo 'selected="selected"'; ?>>India</option>
                                </select>
                </div>
                <div class="items_domain_item">
                        <p>Client Id:</p>
                        <input type="text" name="Client_id" id="textbox" value="<?php echo $zoho_client_id; ?>" required size="60">
		</div>
                <div class="items_domain_item">
                        <p>Client secret:</p>
                        <input type="text" name="Client_secret" id="textbox" value="<?php echo $zoho_client_secret; ?>" required size="60">
                </div>
                <div class="items_domain_item">
                        <p>Redirect Url:</p>
                        <input type="text" name="redirect_url" id="textbox" value="<?php echo $redirect_url; ?>" size="60" disabled>
		</div>
<?php         if ($zoho_books_org){ ?>
<br>
                <div class="items_domain_item">
                        <label for="domain">Choose a Organization: </label><br><br>
				<select name="organization" id="organization">
                                <?php foreach($organizations as $organization) { ?>
				<option value="<?php echo $organization['organization_id']; ?>" <?php if($zoho_books_org==$organization['organization_id']) echo 'selected="selected"'; ?>><?php echo $organization['name']; ?></option>
                                <?php } ?>
                                </select>
                </div>
<?php } ?>
        </div>
        <br>
	<div class="get_link">
<?php if ($wp_option_find) { ?>
                <input id="disconnect" type="submit" name="submit_disconnect" value="Disconnect" class="button">
                <br><br>
                <input id="reauthorize" type="submit" name="submit1" value="ReAuthorize" class="button">
<?php } else { ?>
                <input id="gozoho" type="submit" name="submit1" value="Configure" class="button">
		<br><br>
<?php } ?>
        </div>
</form>
        <div id="request_url" class="go_to_url">
                <a href="<?php echo $request_url; ?>" target="_blank"><?php echo substr_replace($request_url, "", 20); ?></a>
        </div>
</div>

</div>
</div>

<button class="accordion">Order Sync</button>
<div class="panel">
<?php require_once plugin_dir_path(__FILE__) . 'woo-zoho-books-order-sync.php'; ?>
</div>
</button>

</body>
</html>
<script type="text/javascript">
    document.getElementById("zoho").onclick = function () {
        window.open ("https://api-console.zoho.com/");
    };
</script>
